﻿#pragma strict

static var player1Health = 100;
static var player2Health = 100;
static var player1Alive = 1;
static var player2Alive = 1;
static var player1Wins = 0;
static var player2Wins = 0;
static var muteOn = 0;

function Start () {

}

function Update ()
{
	if((player1Health == 0) && (player1Alive == 1))
	{
		audio.Play();
		player1Alive = 0;
		player2Wins++;
	}
	if((player2Health == 0) && (player2Alive == 1))
	{
		audio.Play();
		player2Alive = 0;
		player1Wins++;
	}
	if((player1Alive == 0) || (player2Alive == 0))
	{
		playerWin();
	}
}

function playerWin()
{
	yield WaitForSeconds(8);
	player1Health = 100;
	player2Health = 100;
	player1Alive = 1;
	player2Alive = 1;
	Application.LoadLevel(0);
}

function OnGUI()
{
	if (GUI.Button (Rect(0,Screen.height-30, 50, 30), "MUTE"))
	{
		if(muteOn == 0)
		{
			AudioListener.pause = true;
			muteOn = 1;
		}
		else if(muteOn == 1)
		{
			AudioListener.pause = false;
			muteOn = 0;
		}
	}
	//GUI.backgroundColor = Color.red;
	//GUI.contentColor = Color.red;
	GUI.color = new Color(0.8f,0.2f,0.2f,1f);
	
	var guiStyle1 : GUIStyle;
	
	
	GUI.skin.label.alignment = TextAnchor.UpperCenter;
	//guiStyle1.fontSize = 48;
	//GUI.BeginGroup(new Rect(0,0,1000,100));
	//GUI.Box(new Rect(0,0,1000,100), healthTexture);
	//GUI.EndGroup();
	var p1H = player1Health.ToString();
	var p2H = player2Health.ToString();
	var p1W = player1Wins.ToString();
	var p2W = player2Wins.ToString();
	
	GUI.skin.label.fontSize = 18;
	GUI.Label(Rect(0,0,250,50), "WASD, R / GAMEPAD");
	GUI.Label(Rect(Screen.width-250,0,250,50), "ARROW KEYS, P");
	
	GUI.skin.label.fontSize = 48;
	GUI.Label(Rect(0,10,250,50), p1H);
	GUI.Label(Rect(Screen.width-250,10,250,50), p2H);
	
	GUI.skin.label.fontSize = 130;
	GUI.Label(Rect(0,50,250,300), p1W);
	GUI.Label(Rect(Screen.width-250,50,250,300), p2W);
}

