﻿#pragma strict



var alive = 1;
var tail1 : Sprite;
var tail2 : Sprite;

function Start () {
	
	tail1 = Resources.Load("lobsterTail1", typeof(Sprite)) as Sprite;
	tail2 = Resources.Load("lobsterTailDamage", typeof(Sprite)) as Sprite;
}

function Update ()
{
	var healthColor = 0;
	if(this.transform.parent.parent.name == "1Lobster")
	{
		if(CollisionScript.player1Alive == 0)
		{
			alive = 0;
		}
		healthColor = CollisionScript.player1Health;
	}
	if(this.transform.parent.parent.name == "2Lobster")
	{
		if(CollisionScript.player2Alive == 0)
		{
			alive = 0;
		}
		healthColor = CollisionScript.player2Health;
	}
	
	if(!audio.isPlaying)
	{
		var colorH : float;
		colorH = (healthColor/100f);
		
		var renderer2 : SpriteRenderer;
		renderer2 = GetComponent(SpriteRenderer);
		
		renderer2.color = new Color(colorH,colorH,colorH,1f);

		renderer2.sprite = Resources.Load("lobsterTail1", typeof(Sprite));
	}
}

function OnCollisionEnter2D(col : Collision2D)
{
	//print("COLLISION!!!");

	if(alive)
	{
		if(col.gameObject.tag=="Claw")
		{
			var healthColor = 0;
			if(this.transform.parent.parent.name == "1Lobster")
			{
				CollisionScript.player1Health -= 5;
				if(CollisionScript.player1Health < 0)
				{
					CollisionScript.player1Health = 0;				
				}
				healthColor = CollisionScript.player1Health;
				
			}
			else
			{
				CollisionScript.player2Health -= 5;
				if(CollisionScript.player2Health < 0)
				{
					CollisionScript.player2Health = 0;
				};
				healthColor = CollisionScript.player2Health;
			}


				
			if(!audio.isPlaying)
			{
				audio.Play();

				
				var renderer : SpriteRenderer;
				renderer = GetComponent(SpriteRenderer);

				renderer.color = new Color(1f,1f,1f,1f);
				renderer.sprite = Resources.Load("lobsterTailDamage", typeof(Sprite));
				
			}
		}
	}
}

function OnCollisionStay2D(col : Collision2D)
{
	if(alive)
		{
		//print("COLLISION!!!");
		if(col.gameObject.tag=="Claw")
		{
			if(Time.frameCount % 15 == 0)
			{
				var healthColor = 0;
				if(this.transform.parent.parent.name == "1Lobster")
				{
					CollisionScript.player1Health--;
					if(CollisionScript.player1Health < 0)
					{
						CollisionScript.player1Health = 0;
					}
					healthColor = CollisionScript.player1Health;
				}
				else
				{
					CollisionScript.player2Health--;
					if(CollisionScript.player2Health < 0)
					{
						CollisionScript.player2Health = 0;
					}
					healthColor = CollisionScript.player2Health;
				}

		
				if(!audio.isPlaying)
				{
					audio.Play();
				
				
					var renderer : SpriteRenderer;
					renderer = GetComponent(SpriteRenderer);

					renderer.color = new Color(1f,1f,1f,1f);
					renderer.sprite = Resources.Load("lobsterTailDamage", typeof(Sprite));
				}
			}
			
		}
	}
}