﻿#pragma strict

var alive = 1;

var attack1 : KeyCode;
var moveUp : KeyCode;
var moveDown : KeyCode;
var moveLeft : KeyCode;
var moveRight : KeyCode;
var rotateClockwise : KeyCode;
var rotateCounterClockwise : KeyCode;

var movingUp = 0;
var movingDown = 0;
var movingLeft = 0;
var movingRight = 0;


var speed : float = 50;
var keypressedX = 0;
var keypressedY = 0;
var legForce : float = 1;
var rotateForce : float =  0.00000000001;
var xAxis : float = 0;
var yAxis : float = 0;
var attack : boolean = false;
var forwardVec : Vector2;


var jointPosition : Vector3[];
var footPosition : Vector3[];
var footMovingX : int[];
var footMovingY : int[];
var footTarget : Vector3[];

var xOffset : float;
var lineRenderer : LineRenderer;

var localFootPosition : Vector3;
var distance : float = 1;

var legObj : Transform;
var footObj : Transform;
var jointObj : Transform;
var spriteObj : Transform;
var spriteFootObj : Transform;
var spriteJointObj : Transform;

var clearingAttack = 1;

var playerHealth = 100;

//var hinge : HingeJoint2D[];
//var motor : JointMotor2D[];

var healthTexture : Texture2D;





function Start ()
{
	//footObj = gameObject.transform.Find("Foot");
	//footObj.localPosition = transform.parent.position = Vector3(0,1,0);
	footPosition = new Vector3[8];
	jointPosition = new Vector3[8];
	footMovingX = new int[8];
	footMovingY = new int[8];
	footTarget = new Vector3[8];
	
	for(var x = 0; x < 8; x++)
	{
		footMovingX[x] = 0;
		footMovingY[x] = 0;
		footPosition[x] = gameObject.transform.position;
		jointPosition[x] = gameObject.transform.position; 
	}
	clearingAttack = 1;
	

	lineRenderer = GetComponent(LineRenderer);
	lineRenderer.useWorldSpace = true;
	lineRenderer.SetVertexCount(16);

}

function Update()
{
	movingUp = 0;
	movingDown = 0;
	movingLeft = 0;
	movingRight = 0;
	xAxis = 0;
	yAxis = 0;
	
	if(this.name == "1Lobster")
	{
		if(CollisionScript.player1Alive == 0)
		{
			alive = 0;
		}
	}
	if(this.name == "2Lobster")
	{
		if(CollisionScript.player2Alive == 0)
		{
			alive = 0;
		}
	}

	if(alive)
	{
		
				
		if(this.name == "1Lobster")
		{
			xAxis = Input.GetAxis("Horizontal");
			yAxis = Input.GetAxis("Vertical");
			//print(Input.GetButton("Horizontal"));
		}
		
		if(Input.GetKey(moveUp))
		{
			movingUp = 1;
		}
		if(Input.GetKey(moveDown))
		{
			movingDown = 1;
		}
		if(Input.GetKey(moveLeft))
		{
			movingLeft = 1;
		}
		if(Input.GetKey(moveRight))
		{
			movingRight = 1;
		}

		attack = false;
		if(this.name == "1Lobster")
		{
			attack = Input.GetButton("Fire1");
		}
		if(Input.GetKey(attack1))
		{
			attack = true;
		}
	}

}

function FixedUpdate ()
{

	if(alive)
	{
		
		moveLeg();


		var stableLegs = 0;
		for(var x = 0; x < 8; x++)
		{
			if((footMovingX[x] == 0) && (footMovingY[x] == 0))
			{
				stableLegs++;
			}
		}
		
		//print(stableLegs);
		
		if(stableLegs >=4)
		{ 
			forwardVec.x = transform.forward.x * 5;
			forwardVec.y =  transform.forward.y * 5;
		
			if(this.name == "1Lobster")
			{
				rigidbody2D.AddForce(Vector2(xAxis*legForce,yAxis*legForce));	
			}
			
			if(movingUp == 1)
			{
				rigidbody2D.AddForce(Vector2(0,legForce));
			}
			if(movingDown == 1)
			{
				rigidbody2D.AddForce(Vector2(0,-legForce));
			}
			if(movingLeft == 1)
			{
				rigidbody2D.AddForce(Vector2(-legForce,0));
			}
			if(movingRight == 1)
			{
				rigidbody2D.AddForce(Vector2(legForce,0));
			}
			if(Input.GetKey(rotateClockwise))
			{
				//rigidbody2D.AddForceAtPosition(Vector2(0,-0.3),(rigidbody2D.transform.position + Vector2(1,0)));
			}
			if(Input.GetKey(rotateCounterClockwise))
			{
				//rigidbody2D.AddForceAtPosition(Vector2(0,0.3),(rigidbody2D.transform.position + Vector2(1,0)));
			}
		}
		

		if(attack)
		{
			attack1Function();
		}
		else if(clearingAttack == 1)
		{
			clearAttack();
		}
	}
	else
	{
		moveLegDead();
		turnOffMotors();
	}
}

function turnOffMotors ()
{
	var hinge : HingeJoint2D[];
	var motor : JointMotor2D[];
	motor = new JointMotor2D[8];
	hinge = new HingeJoint2D[8];
	var h = 0;
	var hingeT : HingeJoint2D;
		
	
	hinge[0] = GetComponents(HingeJoint2D)[0];
	hinge[1] = GetComponents(HingeJoint2D)[1];
	hinge[2] = GetComponents(HingeJoint2D)[2];
	
	hinge[1].useMotor = false;
	hinge[2].useMotor = false;
}

function attack1Function ()
{
	var hinge : HingeJoint2D[];
	var motor : JointMotor2D[];
	motor = new JointMotor2D[8];
	hinge = new HingeJoint2D[8];
	var h = 0;
	var hingeT : HingeJoint2D;
	
	//print(GetComponents(HingeJoint2D).Length);
	
	
	hinge[0] = GetComponents(HingeJoint2D)[0];
	hinge[1] = GetComponents(HingeJoint2D)[1];
	hinge[2] = GetComponents(HingeJoint2D)[2];
	
	//hinge[1] = GetComponent(HingeJoint2D);
	//for (var joint : HingeJoint2D in hinge) {
		//joint.motor = motor[1];
	//}
	
	//var hinge : HingeJoint2D[];
	//hinge = gameObject.GetComponents(HingeJoint2D);
	
	
	for(var m = 0; m < 3; m++)
	{
		motor[m] = hinge[m].motor;
	}
	
	motor[1].motorSpeed = -300;
	hinge[1].motor = motor[1];
	
	motor[2].motorSpeed = 300;
	hinge[2].motor = motor[2];
	
	//print(motor[1].motorSpeed);
	clearingAttack = 1;
	
}

function clearAttack ()
{
	var hinge : HingeJoint2D[];
	var motor : JointMotor2D[];
	motor = new JointMotor2D[8];
	hinge = new HingeJoint2D[8];
	var h = 0;
	var hingeT : HingeJoint2D;
	
	//print(GetComponents(HingeJoint2D).Length);
	
	
	hinge[0] = GetComponents(HingeJoint2D)[0];
	hinge[1] = GetComponents(HingeJoint2D)[1];
	hinge[2] = GetComponents(HingeJoint2D)[2];
	
	//hinge[1] = GetComponent(HingeJoint2D);
	//for (var joint : HingeJoint2D in hinge) {
		//joint.motor = motor[1];
	//}
	
	//var hinge : HingeJoint2D[];
	//hinge = gameObject.GetComponents(HingeJoint2D);
	
	
	for(var m = 0; m < 3; m++)
	{
		motor[m] = hinge[m].motor;
	}
	
	motor[1].motorSpeed = 100;
	hinge[1].motor = motor[1];
	//hinge[1].useMotor = false;
	
	motor[2].motorSpeed = -100;
	
	hinge[2].motor = motor[2];
	//hinge[2].useMotor = false;
	
	
	clearingAttack = 0;
	
	//print(motor[1].motorSpeed);
	
}

function moveLeg ()
{
	//legObj = transform.Find("LLeg1");
	//footObj = transform.Find("Foot");
	//jointObj = transform.Find("Joint");
	//spriteObj = transform.Find("LegSprite1");
	//spriteFootObj = spriteObj.transform.Find("Foot");
	//spriteJointObj = spriteObj.transform.Find("Joint");
	//print(legObj);

	//jointPosition = gameObject.transform.position;
	/*
	if(footObj.transform.localPosition.x < -1)
	{
		footObj.transform.localPosition.x = 1;

	}s
	if(footObj.transform.localPosition.x > 1.1)
	{
		footObj.transform.localPosition.x = -0.9;
	}
	if(footObj.transform.localPosition.y < 0.3)
	{
		footObj.transform.localPosition.y = 1;
	
	}
	if(footObj.transform.localPosition.y > 1.1)
	{
		footObj.transform.localPosition.y = 0.5;
	}
	*/
	//footPosition = footObj.localPosition.magnitude;
	
	//distance = footObj.localPosition.magnitude;

	//legObj.transform.localScale.x = distance;
	//jointObj.transform.localPosition = Vector3(0,0,0);
	
	lineRenderer = GetComponent(LineRenderer);
	
	var yMultiplier = 1;
	xOffset = 0;
	var change = 0;
	var footMoveSpeed = 0.1;
	var emitParticle = 0;
	
	for(var x = 0; x < 8; x++)
	{
		change = 0;
		emitParticle = 0;
		localFootPosition = transform.InverseTransformPoint(footPosition[x]);
		
		if(x>=4)
		{
			yMultiplier = -1;
		}
		
		xOffset = (x%4)*0.3;
		
		if((localFootPosition.x < (-1 + xOffset)) && (footMovingX[x] == 0))
		{
			footTarget[x].x = xOffset;
			footMovingX[x] = 1;
			change = 1;
		}	
		if((localFootPosition.x > xOffset) && (footMovingX[x] == 0))
		{
			footTarget[x].x = (-1 + xOffset);
			footMovingX[x] = -1;
			change = 1;
		}
		
		if(footMovingX[x] == 1)
		{
			if(localFootPosition.x < footTarget[x].x)
			{
				localFootPosition.x += footMoveSpeed;
				if(localFootPosition.x > footTarget[x].x)
				{
					localFootPosition.x = footTarget[x].x;
					footMovingX[x] = 0;
					emitParticle = 1;
				}
			}
			
			else
			{
				footMovingX[x] = 0;
				emitParticle = 1;
			}
		}
		if(footMovingX[x] == -1)
		{
			if(localFootPosition.x > footTarget[x].x)
			{
				localFootPosition.x -= footMoveSpeed;
				if(localFootPosition.x < footTarget[x].x)
				{
					localFootPosition.x = footTarget[x].x;
					footMovingX[x] = 0;
					emitParticle = 1;
				}
			}
			else
			{
				footMovingX[x] = 0;
				emitParticle = 1;
			}
		}
		
		
		if(((localFootPosition.y * yMultiplier) < 0.3) && (footMovingY[x] == 0))
		{
			footTarget[x].y = (1.2 * yMultiplier);
			footMovingY[x] = yMultiplier;
			change = 1;
		
		}
		if(((localFootPosition.y * yMultiplier) > 1.2) && (footMovingY[x] == 0))
		{
			footTarget[x].y = (0.3 * yMultiplier);
			footMovingY[x] = yMultiplier * -1;
			change = 1;
		}
		
		if(footMovingY[x] == 1)
		{
			if(localFootPosition.y < footTarget[x].y)
			{
				localFootPosition.y += footMoveSpeed;
				if(localFootPosition.y > footTarget[x].y)
				{
					localFootPosition.y = footTarget[x].y;
					footMovingY[x] = 0;
					emitParticle = 1;
				}
			}
			
			else
			{
				footMovingY[x] = 0;
				emitParticle = 1;
			}
			
		}
		if(footMovingY[x] == -1)
		{
			if(localFootPosition.y > footTarget[x].y)
			{
				localFootPosition.y -= footMoveSpeed;
				if(localFootPosition.y < footTarget[x].y)
				{
					localFootPosition.y = footTarget[x].y;
					footMovingY[x] = 0;
					emitParticle = 1;
				}
			}
			else
			{
				footMovingY[x] = 0;
				emitParticle = 1;
			}
		}
		
		
		footPosition[x] = transform.TransformPoint(localFootPosition);
		jointPosition[x] = gameObject.transform.position;
		footPosition[x].z = 1;
		jointPosition[x].z = 1;
		 
		lineRenderer.SetPosition((2*x),jointPosition[x]);
		lineRenderer.SetPosition(((2*x)+1),footPosition[x]);
		
		if(emitParticle == 1)
		{
			if(footMovingX[x] == 0)
			{
				//particleEmitter.emit = true;
				footPosition[x].z = 5;
				particleSystem.Emit(footPosition[x], Vector3(0f,0f,0f), 0.7f, 999f, Color(0.898f, 0.745f, 0.561f,1f));
				footPosition[x].z = 4;
				particleSystem.Emit(footPosition[x], Vector3(0f,0f,0f), 0.05f, 999f, Color(0f, 0f, 0f,1f)); 		
			
			}
		}
	}
	

    
    
	
	
	//Debug.DrawLine(Vector3(0,0,0),Vector3(0,10,0),Color.red, 10);
	
	//footObj.position = footPosition;
	//jointObj.position = jointPosition;
}

function moveLegDead ()
{
	lineRenderer = GetComponent(LineRenderer);
	
	var yMultiplier = 1;
	xOffset = 0;
	var change = 0;
	var footMoveSpeed = 0.1;
	 
	for(var x = 0; x < 8; x++)
	{
		change = 0;
		localFootPosition = transform.InverseTransformPoint(footPosition[x]);
		
		if(x>=4)
		{
			yMultiplier = -1;
		}
		
		xOffset = (x%4)*0.3;
		
		localFootPosition.x = xOffset - 0.4;
		localFootPosition.y = 0;
		
		footPosition[x] = transform.TransformPoint(localFootPosition);
		jointPosition[x] = gameObject.transform.position;
		footPosition[x].z = 1;
		jointPosition[x].z = 1;
		 
		lineRenderer.SetPosition((2*x),jointPosition[x]);
		lineRenderer.SetPosition(((2*x)+1),footPosition[x]);
	}
}